// MATRIX Class
// (c) by Heinrich Tillack 2002 (http://a128.x15.org)
// under GPL or new BSD license
// v 0 (21.10.02): initial release
#ifndef MatrixH
#define MatrixH

#include "vec3.h"
#include "quat.h"
#include <kos.h>
#include <GL/gl.h>

class MATRIX
{
public:
    MATRIX();
    ~MATRIX();
    void	Print();

    GLvoid LoadIdentity();
    GLvoid CopyMatrix(GLfloat m[16]);
    GLvoid MultMatrix(GLfloat m[16]);
    GLvoid MatrixInverse();
    GLvoid MatrixFromAxisAngle(Vec3 axis, GLfloat theta);
    GLvoid QuatToMatrix(QUAT quat);

    union
    {
        struct
        {
            float _11, _12, _13, _14;
            float _21, _22, _23, _24;
            float _31, _32, _33, _34;
            float _41, _42, _43, _44;
        } __attribute__((aligned(32)));
        GLfloat	_m[16] __attribute__((aligned(32)));
        matrix_t  _dcm __attribute__((aligned(32)));
    };
private:

    void inline	Load()
    {

        mat_load(&_dcm);
    }
    void inline	Apply()
    {

        mat_apply(&_dcm);
    }
    void	inline Store()
    {

        mat_store(&_dcm);
    }
};

#endif

